/*	
 *	framds13.c
 *
 *	RAM]FXLC`֐iyrE1bitmaskeNX`j
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Aug  2 05:00:00 JST 2004 Naoyuki Sawa
 *	- clipren3.cړĂ܂B
 */
#include "clip.h"

/*****************************************************************************
 *	
 *****************************************************************************/

void
draw_scanline_wz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	unsigned char* zptr;	/* yobt@|C^         */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA z;			/* ylDDA                    */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char zval;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;
	zptr = param->surface_zbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	DRAW_SCANLINE_SETUP(z);
	DRAW_SCANLINE_SETUP(s);
	DRAW_SCANLINE_SETUP(t);

	/* DDA[vB */
	n = nx;
	do {
		/* yrB */
		zval = (unsigned char)(cur.z >> 8);
		if(zval <= *zptr) {
			/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
			 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
			 * R[hTCYƂ̌ˍŁÂőË܂B
			 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
			 */
			sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
			tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
			ofs = param->texture_w * tval + sval;
			if(param->texture_mask[ofs / 8] >> (7 - (ofs & 7)) & 1) {
				/* 1biteNX`ȂAeNZlɂ 1:tFCX̑OiF/0:tFCX̔wiF ŕ`܂B */
				*vptr = param->texture_buf[ofs / 8] >> (7 - (ofs & 7)) & 1 ? param->fore_color : param->back_color;
				*zptr = zval;
			}
		}
		/* obt@|C^i߂܂B */
		vptr++;
		zptr++;
		/* DDAXebvsB */
		DRAW_SCANLINE_STEP(z);
		DRAW_SCANLINE_STEP(s);
		DRAW_SCANLINE_STEP(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}

